Gecode::Search::Builder Class Referenceabstract

A class for building search engines. More...

`#include <search.hh>`

## Public Member Functions

| Builder (const Options &opt, bool best)
| Initialize with options opt and best solution search support.
Options & | options (void)
| Provide access to options.
const Options & | options (void) const
| Provide access to options.
bool | best (void) const
| Whether engine is a best solution search engine.
virtual Engine * | operator() (Space *s) const =0
| Build an engine according to stored options for s.
virtual | ~Builder (void)
| Destructor.

## Protected Attributes

Options | opt
| Stored and already expanded options.
const bool | b
| Whether engine to be built is a best solution search engine.

## Additional Inherited Members

Static Public Member Functions inherited from Gecode::HeapAllocated
static void * | operator new (size_t s)
| Memory management.
static void | operator delete (void *p)
| Free memory allocated from heap.

## Detailed Description

A class for building search engines.

Definition at line 965 of file search.hh.

## Constructor & Destructor Documentation

## Builder()

Gecode::Search::Builder::Builder | ( | const Options & | opt,
|  | bool | best )

inline

Initialize with options opt and best solution search support.

Definition at line 37 of file build.hpp.

## ~Builder()

Gecode::Search::Builder::~Builder | ( | void |  | ) |

inline virtual

Destructor.

Definition at line 52 of file build.hpp.

## Member Function Documentation

## options() [1/2]

Options & Gecode::Search::Builder::options | ( | void |  | ) |

inline

Provide access to options.

Definition at line 40 of file build.hpp.

## options() [2/2]

const Options & Gecode::Search::Builder::options | ( | void |  | ) | const

inline

Provide access to options.

Definition at line 44 of file build.hpp.

## best()

bool Gecode::Search::Builder::best | ( | void |  | ) | const

inline

Whether engine is a best solution search engine.

Definition at line 48 of file build.hpp.

## operator()()

virtual Engine * Gecode::Search::Builder::operator() | ( | Space * | s | ) | const

pure virtual

Build an engine according to stored options for s.

Implemented in Gecode::Search::BabBuilder< T >, Gecode::Search::DfsBuilder< T >, Gecode::Search::LdsBuilder< T >, Gecode::Search::PbsBuilder< T, E >, and Gecode::Search::RbsBuilder< T, E >.

## Member Data Documentation

## opt

Options Gecode::Search::Builder::opt

protected

Stored and already expanded options.

Definition at line 968 of file search.hh.

## b

const bool Gecode::Search::Builder::b

protected

Whether engine to be built is a best solution search engine.

Definition at line 970 of file search.hh.

The documentation for this class was generated from the following files:

- gecode/search.hh
- gecode/search/build.hpp